package com.base.appzxhy.ui.splash

import android.Manifest
import android.annotation.SuppressLint
import android.content.Intent
import android.os.Build
import android.os.Bundle
import android.text.SpannableString
import android.text.Spanned
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.text.style.UnderlineSpan
import android.util.Log
import android.view.View
import androidx.activity.viewModels
import androidx.core.graphics.toColorInt
import androidx.core.net.toUri
import androidx.core.view.ViewCompat
import androidx.core.view.WindowInsetsCompat
import androidx.lifecycle.lifecycleScope
import com.base.appzxhy.GlobalConfig.URL_PRIVACY
import com.base.appzxhy.GlobalConfig.URL_USE
import com.base.appzxhy.MyApplication
import com.base.appzxhy.SpConstObject.ifAgreePrivacy
import com.base.appzxhy.SpConstObject.isGuided
import com.base.appzxhy.base.BaseActivity
import com.base.appzxhy.base.jumpAction
import com.base.appzxhy.bean.FeatureBean.Companion.BATTERY_INFO
import com.base.appzxhy.business.ads.AdsMgr
import com.base.appzxhy.business.ads.AdsShowCallBack
import com.base.appzxhy.business.helper.EventUtils
import com.base.appzxhy.business.helper.NewComUtils
import com.base.appzxhy.business.helper.NewComUtils.requestCfgCallBack
import com.base.appzxhy.business.helper.NewComUtils.spConfig
import com.base.appzxhy.business.service.StayJobService.Companion.startStayJobService
import com.base.appzxhy.databinding.ActivitySplashBinding
import com.base.appzxhy.ui.dialog.StoragePermissionDialog
import com.base.appzxhy.ui.guide.GuideCleanActivity
import com.base.appzxhy.ui.main.MainActivity
import com.base.appzxhy.utils.PermissionUtils.checkStorePermission
import com.base.appzxhy.utils.PermissionUtils.requestStoragePermission
import com.base.appzxhy.utils.UmpUtils
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch
import java.util.concurrent.atomic.AtomicBoolean


@SuppressLint("CustomSplashScreen")
class SplashActivity : BaseActivity<ActivitySplashBinding>(ActivitySplashBinding::inflate) {

    private val viewModel: SplashViewModel by viewModels()

    override fun onWindowFocusChanged(hasFocus: Boolean) {
        super.onWindowFocusChanged(hasFocus)
    }

    override fun useDefaultImmersive() {
        ViewCompat.setOnApplyWindowInsetsListener(binding.root) { v, insets ->
            val systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars())
            v.setPadding(systemBars.left, 0, systemBars.right, systemBars.bottom)
            insets
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
//        initUMP()
        super.onCreate(savedInstanceState)
        handleIntentExtras()
    }

    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        viewModel.startCountdown()
    }

    override fun onStop() {
        super.onStop()
        viewModel.stopCountdown()
    }

    override fun initView() {
        super.initView()
        showLoadingAd()
        setPrivacyPolicy()
        requestNotificationPermission()
    }

    private fun setPrivacyPolicy() {

        val spannableString = SpannableString("privacy")
        spannableString.setSpan(UnderlineSpan(), 0, spannableString.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)
        spannableString.setSpan(object : ClickableSpan() {
            override fun onClick(widget: View) {
                startActivity(Intent(Intent.ACTION_VIEW, URL_PRIVACY.toUri()))
            }
        }, 0, spannableString.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)

        binding.tvPrivacy.text = spannableString
        binding.tvPrivacy.movementMethod = LinkMovementMethod.getInstance()
        binding.tvPrivacy.setLinkTextColor("#328EF6".toColorInt())

        val spannableString2 = SpannableString("terms of service")
        spannableString2.setSpan(UnderlineSpan(), 0, spannableString2.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)
        spannableString2.setSpan(object : ClickableSpan() {
            override fun onClick(widget: View) {
                startActivity(Intent(Intent.ACTION_VIEW, URL_USE.toUri()))
            }
        }, 0, spannableString2.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)

        binding.tvTerms.text = spannableString2
        binding.tvTerms.movementMethod = LinkMovementMethod.getInstance()
        binding.tvTerms.setLinkTextColor("#328EF6".toColorInt())

    }

    private fun requestNotificationPermission() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            val array = arrayOf(Manifest.permission.POST_NOTIFICATIONS)
            launcher.launch(array) { permissions ->
                val flag = permissions.values.all { it }
                if (flag) MyApplication.appContext.startStayJobService()
            }
        }
    }

    override fun initListener() {
        super.initListener()
        binding.tvStart.setOnClickListener {
            ifAgreePrivacy = true
            showLoadingAd()
            EventUtils.event("app_start")
            EventUtils.event("page_${javaClass.simpleName}")
            viewModel.startCountdown()
            MyApplication.appContext.initApp()
        }
    }

    override fun handleBackCallBack() {

    }

    private fun initUMP() {
        val ump = UmpUtils(this)

        if (ump.consentInformation.canRequestAds()) {
            AdsMgr.init(this)
        } else {
            ump.callback = {
                AdsMgr.init(this)
            }
            ump.requestUMP()
        }
    }

    private fun showLoadingAd() {
        binding.clBottomStart.visibility = if (ifAgreePrivacy) View.GONE else View.VISIBLE
        binding.clBottomLoading.visibility = if (ifAgreePrivacy) View.VISIBLE else View.GONE
        binding.llConsent.visibility = if (ifAgreePrivacy) View.GONE else View.VISIBLE

        if (ifAgreePrivacy) {

            val acAction = {
                AdsMgr.showOpen(this, showCallBack = object : AdsShowCallBack() {
                    override fun show() {
                        viewModel.stopCountdown()
                    }

                    override fun next() {
                        binding.root.postDelayed({ jumpNext() }, 200)
                    }

                })
            }

            if (spConfig.isNotEmpty()) {
                Log.e(TAG, "1")
                acAction.invoke()
            } else {
                if (NewComUtils.requestCfgIng.get()) {
                    requestCfgCallBack = {
                        lifecycleScope.launch(Dispatchers.Main) {
                            Log.e(TAG, "2")
                            acAction.invoke()
                        }
                    }
                } else {
                    Log.e(TAG, "3")
                    acAction.invoke()
                }
            }
        }
    }

    val jumped = AtomicBoolean(false)
    fun jumpNext() {
        if (jumped.get()) return
        jumped.set(true)

        when {
            !isGuided -> {
                isGuided = true
                goToAc(GuideCleanActivity::class.java)
                finish()
            }

            isHotLaunch -> {
                goToAc(MainActivity::class.java)
                finish()
            }

            actionId.isNotEmpty() -> {
                actionIdJump()
            }

            else -> {
                goToAc(MainActivity::class.java)
                finish()
            }
        }
        intent.extras?.clear()
    }

    fun actionIdJump() {
        when (actionId) {
            BATTERY_INFO -> {
                jumpAction(actionId)
                finish()
            }

            else -> {
                if (checkStorePermission()) {
                    jumpAction(actionId)
                    finish()
                } else {
                    val dialog = StoragePermissionDialog(this)
                    dialog.action = {
                        requestStoragePermission(launcher) {
                            if (it) {
                                jumpAction(actionId)
                                finish()
                            } else {
                                goToAc(MainActivity::class.java)
                                finish()
                            }
                        }
                    }
                    dialog.showDialog()
                }
            }

        }
    }


    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        handleIntentExtras()
    }

    var isHotLaunch: Boolean = false
    var actionId = ""
    fun handleIntentExtras() {
        super.onNewIntent(intent)
        actionId = intent?.extras?.getString("actionId") ?: ""
        isHotLaunch = intent?.extras?.getBoolean("isHotLaunch") == true
    }

}